;
; Club Info 100 Intro
; Written by Csabo of LOD
;	
	ORG $1001-2
	DW  $1001
	
	DW $100B,0
	DB $9E,"4109",0,0,0
	
shutdown	= $07

src	= $C0
dst	= $C2
src2	= $C4
dst2	= $C6

col	= $C8

delay	= $BE
speed	= $BF

num_src	= $CA
num_dst	= $CC
num_ptr	= $CE

sprite_pos	= $D0
sp1		= $D2
sp2		= $D4
sprite_anim	= $D6

voldown_tab	= $D8

zero_page_save	= $7F00		; anywhere in upper mem

; start
	SEI
	STA $FF3F
	;
	LDX #$02
zps	LDA $00,x
	STA zero_page_save,x
	INX
	BNE zps
	;
	INX			; X=1 clear screen
	LDY #$08
	LDA #$2E
	JSR fill
	;
	LDX #$01
	LDA #$39
	JSR fill1
	;
	LDX #$03
	TYA
	JSR fill1
	;
	STY shutdown		; clear shutdown flag
	;
	STY $FF15
	STY $FF19
	LDA #$71
	STA $FF16
	LDA #$41
	STA $FF17
	;
	LDA $FF07
	AND #$40
	ORA #$98
	STA $FF07
	;
	LDA #$C3
	STA $FF12
	LDA #charset >> 8
	STA $FF13
	;
	; ---
	;
	LDA #22			; init sprite (last frame-1)
	STA sprite_anim
	;
	; --- init IRQ for music
	;
	LDX #$04
irqc1	LDA irq_null,x		; copy irq to $0110 area
	STA $0108,x
	;
	DEX
	BPL irqc1
	;
	LDX #irq_digi_end - irq_digi - 1
irqc2	LDA irq_digi,x
	STA $08,x
	DEX
	BPL irqc2
	;
	LDX #irq_digi_nextbyte_end - irq_digi_nextbyte
irqc3	LDA irq_digi_nextbyte,x
	STA $0208,x
	DEX
	BPL irqc3
	;
	LDA #$08
	STA $FFFE
	LDX #$01
	STX $FFFF    
	INX
	STX delay		; initial delay
	;
	JSR PLAYER_INIT
	JSR digi_init
	;
	LDA #voldown_table & 255
	STA voldown_tab 
	LDA #voldown_table >> 8
	STA voldown_tab+1 
	;
	; ---
	;
	LDA #num_data & 255	; init numbers
	STA num_ptr
	LDA #num_data >> 8
	STA num_ptr+1
	;
	JSR sync_CC
	LDA #$1B
	STA $FF06
	;
	; ---
	;
main
	LDY #$6F		; first sync for logo stuff
	JSR sync
	;
	JSR check_space
	;
	;LDA #$78
	;STA $FF16
	;LDA #$58
	;STA $FF17
	;
	;DEC $FF15
	JSR do_logo
	;INC $FF15
	;       
	;INC $FF19
	LDY #$F8		; second sync for numbers
	JSR sync		; just fits PAL & NTSC :-) 
	;DEC $FF19
	;
	JSR do_fade_numbers
	;
	DEC delay
	BEQ do_print_number
	LDA delay
	CMP #$01
	BNE main
	;
	LDA #$24		; beep
	STA $FF11
	BNE main
	;
do_print_number
	LDA #$00		; sound off
	STA $FF11
	;
number_print_loop
	LDY #$00
	;
	LDA (num_ptr),y		; $FF is a flag...
	CMP #$FF
	BNE its_a_pos
	;
	INC num_ptr
	BNE *+4
	INC num_ptr+1
	;
	LDA (num_ptr),y		; next byte sets delay
	STA speed
	;
	INC num_ptr
	BNE *+4
	INC num_ptr+1
	;
	JMP number_print_loop
	;            
its_a_pos
	LDA #$0E
	STA num_dst+1
	LDA (num_ptr),y
	;
	INC num_ptr
	BNE *+4
	INC num_ptr+1
	;
	CMP #$00
	BEQ num_frame_done
	;
	STA num_dst
	;
	LDA #numbers >> 8
	STA num_src+1
	LDA (num_ptr),y
	STA num_src
	;
	INC num_ptr
	BNE *+4
	INC num_ptr+1
	;
	JSR copy_number
	;
	JMP number_print_loop 
	
num_frame_done
	;
	;INC $FF19
	;
	LDA num_dst
	CMP #$D6		; ugly constant :-)
	BEQ start_music
	;
	LDX #$02		; speedup
	LDA shutdown
	BNE speed_up
	LDX speed   
speed_up
	STX delay
	;
	JMP main
	;
	; -------------------
	;              
start_music
	JSR digi_start
	;
x1	JSR sync_CC
	;
	;DEC $FF19
	;
rs1	LDA restore_sprite
	LDA #$20
	STA rs1
	;
dl1	BIT do_logo
	JSR do_fade_numbers
	;
	JSR check_space
	;
	LDA dl1			; ensure this only kicks in once
	CMP #$20
	BEQ dp1
	LDA shutdown		; shutting down?
	BEQ dp1
	LDA scroll+1		; logo stopped scrolling?
	CMP #189
	BNE dp1
	LDA $FFFF		; digi note stopped playing?
	CMP #$01
	BNE dp1
	;
	LDA #$20		; JSR $0000 opcode
	STA dl1			; enable logo scrolling
	;
	LDA #$A5		; LDA $00 opcode
	STA digi_note_length	; stop digi from playing next note
	;
	INC scroll+1		; start scroll again to remove logo 
	;
dp1	JSR do_sprite
	JSR do_voldown
	;INC $FF19
	;
	;INC $FF19
	JSR PLAYER 
	;DEC $FF19
	;
	JMP x1
	;
	; ###################################
	;
copy_number
	LDX #9
	;
cn2	LDY #$04
cn1	LDA (num_src),y
	ORA #$80
	STA (num_dst),y
	DEY
	BPL cn1
	;
	LDA num_src
	CLC
	ADC #50
	STA num_src
	BCC *+4
	INC num_src+1
	;
	LDA num_dst
	CLC
	ADC #40
	STA num_dst
	BCC *+4
	INC num_dst+1
	;
	DEX
	BPL cn2
	;
	RTS
	
	; ####################################################
	
do_logo	
	LDX #39
col_loop
	STX col
	;
	TXA
	CLC
scroll	ADC #$00
	TAY
	;             
	LDA logo_appear,y
	BNE dont_skip_column
	JMP skip_column
dont_skip_column
	STA size_ptr+1
	;
	STX dst
	STX dst2
	LDA #$08
	STA dst2+1
	LDA #$0C
	STA dst+1
	;
	LDA #charmap & 255
	CLC
	ADC mul14_lo,x
	STA src
	LDA #charmap >> 8
	ADC mul14_hi,x
	STA src+1
	;
	LDA #colormap & 255
	CLC
	ADC mul14_lo,x
	STA src2
	LDA #colormap >> 8
	ADC mul14_hi,x
	STA src2+1
	;
	LDY #$00
	;
	LDX #13
row_loop
	;
size_ptr
	LDA size0,x
	BEQ no_add
	PHA
	CLC
	ADC src
	STA src
	BCC *+4
	INC src+1
	;   
	PLA
	CLC
	ADC src2
	STA src2
	BCC *+4
	INC src2+1
	;
no_add	LDA (src),y	; copy one char
	STA (dst),y
	;
	LDA (src2),y	; copy color
	STA (dst2),y
	;
	LDA dst
	CLC
	ADC #40
	STA dst
	STA dst2
	BCC *+6
	INC dst+1
	INC dst2+1
	;
	DEX
	BPL row_loop
	;
skip_column
	LDX col
	DEX
	BPL col_loop
	;BMI loop_done
	;JMP col_loop 
loop_done
	;
	LDA scroll+1
	CMP #189
	BEQ stop_logo
	CMP #253
	BEQ stop_logo
	INC scroll+1
	;
stop_logo
	RTS
	
	; ####################################################
	
restore_sprite
	LDY #1
	LDA sprite_save   
	STA (sprite_pos),y
	;
	LDY #40
	LDA sprite_save+1
	STA (sprite_pos),y
	INY              
	LDA sprite_save+2
	STA (sprite_pos),y
	INY
	LDA sprite_save+3
	STA (sprite_pos),y
	;
	LDY #81           
	LDA sprite_save+4
	STA (sprite_pos),y
	RTS
	
do_sprite
	;
	; --- animate
	;    
	LDA sprite_anim
	CLC
	ADC #$01
	CMP #23
	BNE no_sprite_anim_wrap
	;
	LDA shutdown
	BEQ no_sd1   
	;
	LDA #$2C		; BIT $0000 opcode
	STA rs1+4		; self-mod, disable call to restore sprite
	;
	RTS
	;         
no_sd1
spp1	LDA #$00
	INC spp1+1
	AND #$07
	ASL a
	TAX
spp2	LDA #$00
	ADC #13
	STA spp2+1
	AND #$1F
	CLC
	ADC sp_pos,x
	STA sprite_pos
	LDA sp_pos+1,x
	ADC #$00
	STA sprite_pos+1
	;
	LDA #$00
no_sprite_anim_wrap
	STA sprite_anim
	ASL A
	TAX
	;
	LDA anim_ptrs,x
	STA anim_ptr+1
	LDA anim_ptrs+1,x
	STA anim_ptr+2
	;
	; ---
	;
draw_sprite
	;
	; --- get the original chars from the screen, and draw sprite chars
	;
	LDY #1
	LDA (sprite_pos),y
	STA sprite_save   
	LDA #$80-5
	STA (sprite_pos),y
	;       
	LDY #40
	LDA (sprite_pos),y
	STA sprite_save+1
	LDA #$80-4
	STA (sprite_pos),y
	INY              
	LDA (sprite_pos),y
	STA sprite_save+2
	LDA #$80-3
	STA (sprite_pos),y
	INY              
	LDA (sprite_pos),y
	STA sprite_save+3
	LDA #$80-2
	STA (sprite_pos),y
	;
	LDY #81           
	LDA (sprite_pos),y
	STA sprite_save+4
	LDA #$80-1
	STA (sprite_pos),y  
	;       
	; --- copy character data to buffer
	;
	LDA #(charset + $400 - 5 * 8) & 255
	STA sp2
	LDA #(charset + $400 - 5 * 8) >> 8
	STA sp2+1
	;
	LDX #$00
	LDY #$00
ds0	LDA sprite_save,x
	STA sp1
	LDA #$00
	STA sp1+1
	;
	;JMP*
	ASL sp1
	ROL sp1+1
	ASL sp1
	ROL sp1+1
	ASL sp1
	ROL sp1+1
	;
	LDA sp1+1
	ORA #charset >> 8
	STA sp1+1
	;
	TXA
	ASL A
	ASL A
	ASL A
	STA tmp1+1
	;
	LDA sp1
	SEC
tmp1	SBC #$00
	STA sp1
	BCS *+4
	DEC sp1+1
	;    
ds1	
anim_ptr
	LDA star_anim + 4*$28,y
	PHA
	AND #$AA
	EOR #$FF
	STA and_v+1
	;
	PLA
	AND #$55
	STA ora_v+1
	;
	LDA (sp1),y
and_v	AND #$00
ora_v	ORA #$00
	STA (sp2),y
	INY
	TYA
	AND #$07
	BNE ds1
	;
	INX
	CPX #5
	BNE ds0
	;
	RTS
	
	; ###############################
	
check_space
	LDA #$7F
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$10	; Query keyboard for "Space"
	BNE not_pressed
	; space is pressed
	LDA #$01
	STA shutdown
	;
not_pressed
	RTS
	
	; ###############################
	
pos1 = $41 ; $0E41

pos2 = pos1-2
pos3 = pos2+5

pos4 = pos1-5
pos5 = pos1
pos6 = pos1+5
	
do_fade_numbers
	LDA shutdown
	BEQ df4
	;
	LDA scroll+1
	CMP #253
	BNE df4
	;
df0	LDA #$03
	CLC
	ADC #$01
	AND #$03
	STA df0+1
	;
	BEQ fade_chars
	;
	CMP #$01
	BEQ fade_ff16
	;
	CMP #$02
	BEQ fade_ff17
	;
	RTS
	
fade_ff17
	LDX #$01
	DB $2C
fade_ff16
	LDX #$00
	LDA $FF16,x
	AND #$7F
	SEC
	SBC #$10
	BPL df1
	LDA #$00
df1	STA $FF16,x
	RTS
	
fade_chars
	LDA pos4+$A00
	SEC
	SBC #$10
	BPL df2
	LDA #$08		; multicolor black
df2	;
	LDY #14
df3	STA pos4+$A00+00*40,y
	STA pos4+$A00+01*40,y
	STA pos4+$A00+02*40,y
	STA pos4+$A00+03*40,y
	STA pos4+$A00+04*40,y
	STA pos4+$A00+05*40,y
	STA pos4+$A00+06*40,y
	STA pos4+$A00+07*40,y
	STA pos4+$A00+08*40,y
	STA pos4+$A00+09*40,y
	DEY
	BPL df3
	;
df4	RTS
	
	
	; ###############################
	
do_voldown
	LDA shutdown
	BEQ ve
	;
	LDX vd_slow+1
	INX
	CPX #$06			; slow down value
	BNE *+4
	LDX #$00
	STX vd_slow+1
	;
vd_slow	LDA #$00			; slow down to 'n' frames
	BNE ve
	;
	LDA voldown_tab			; go through voldown table
	CLC
	ADC #$09			; 9 bytes at a time
	STA voldown_tab
	BCC *+4
	INC voldown_tab+1
	;              
	LDA voldown_tab
	CMP #voldown_table_end & 255
	BEQ final_jump
	;
ve	RTS
	;
	; #############################
	;
final_jump	
	;
	; --- clean up!
	;     
	SEI
	STA $FF3F
	;
	JSR sync_CC		; play it nice and safe, sync it...
	;   
	LDA $FF07
	AND #$40
	ORA #$08
	STA $FF07		; restore ff07
	LDA #$C4
	STA $FF12		; and font
	LDA #$D1
	STA $FF13     
	;
	LDA #$A2		; restore irq
	STA $FF0A
	ASL $FF09
	;        
	LDA #$B3
	STA $FFFE
	LDA #$FC
	STA $FFFF
	;
	LDX #$07		; clear screen
	LDY #$08
	LDA #$20
	JSR fill
	;
	LDA #$71		; font color to white just in case
	STA $053B
	;
	LDX #$02
zpr	LDA zero_page_save,x
	STA $00,x
	INX
	BNE zpr
	;
	; ---
	;
	LDX #$07
lc0	LDA prg_size,x
	STA $2B,x
	DEX
	BPL lc0
	;
	TXS			; X=$FF
	;
	STX $75			; flag graphics mode
	;
	LDX #loader_call_end - loader_call
lc1	LDA loader_call,X
	STA $0123,X
	LDA #$00
	STA $1000,x	; clear $1000 area in case of load error
	STA $4000,x	; clear $4000 area too
	DEX
	BPL lc1
	JMP $0123
	;
prg_size
	DW $4001,$6008,$6008,$6008
	;
	; *** Start ***
	;
loader_call
	STA $FF3E
	CLI
device	LDX #$08
	LDA #$01
	LDY #$00
	STY $90
	STY $F9
	JSR $FFBA	; KERNAL: SETLFS (Set LA, FA, SA)
	LDA #$04	; length
	LDX #$4F	; filename ptr ($014F)
	LDY #$01
	JSR $FFBD	; KERNAL: SETNAM (Set length and filename address)
	LDA #$00
	LDX #$01
	LDY #$40
	JSR $FFD5	; KERNAL: LOADSP (Load from file)
	JSR $FFB7	; KERNAL: READSS (Return I/O STATUS byte)
	;    
	JSR $8BBE	; RUN command
	JMP $8BDC
	;
	DB "HAU*"
	;
loader_call_end
	
	include "common.asm"
	
	; ###############################
	
sprite_save
	DS 5
	
star_anim
	; 40*40 m
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$30,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$30,$FC,$30,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$30,$30,$FC,$30,$30,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$03,$00,$00,$00,$00
	DB $30,$30,$30,$FF,$30,$30,$30,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00

	DB $00,$00,$00,$00,$00,$00,$00,$30
	DB $00,$00,$00,$03,$00,$00,$00,$00
	DB $30,$30,$30,$FF,$30,$30,$30,$30
	DB $00,$00,$00,$00,$00,$00,$00,$00
	DB $00,$00,$00,$00,$00,$00,$00,$00
	
	DB $00,$00,$00,$00,$00,$00,$30,$30
	DB $00,$00,$00,$0F,$00,$00,$00,$00
	DB $30,$30,$FC,$FF,$FC,$30,$30,$30
	DB $00,$00,$00,$C0,$00,$00,$00,$00
	DB $30,$00,$00,$00,$00,$00,$00,$00

	DB $00,$00,$00,$00,$00,$30,$30,$30
	DB $00,$00,$00,$0F,$00,$00,$00,$00
	DB $30,$30,$FC,$FF,$FC,$30,$30,$30
	DB $00,$00,$00,$C0,$00,$00,$00,$00
	DB $30,$30,$00,$00,$00,$00,$00,$00
	
	DB $00,$00,$00,$00,$30,$30,$30,$30
	DB $00,$00,$00,$3F,$00,$00,$00,$00
	DB $30,$FC,$FC,$FF,$FC,$FC,$30,$30
	DB $00,$00,$00,$F0,$00,$00,$00,$00
	DB $30,$30,$30,$00,$00,$00,$00,$00

	DB $00,$00,$00,$30,$30,$30,$30,$30
	DB $00,$00,$00,$3F,$00,$00,$00,$00
	DB $30,$FC,$FC,$FF,$FC,$FC,$30,$30
	DB $00,$00,$00,$F0,$00,$00,$00,$00
	DB $30,$30,$30,$30,$00,$00,$00,$00
	
	DB $00,$00,$30,$30,$30,$30,$30,$30
	DB $00,$00,$03,$FF,$03,$00,$00,$00
	DB $FC,$FC,$FF,$FF,$FF,$FC,$FC,$30
	DB $00,$00,$00,$FC,$00,$00,$00,$00
	DB $30,$30,$30,$30,$30,$00,$00,$00
	
	DB $00,$30,$30,$30,$30,$30,$30,$30
	DB $00,$00,$03,$FF,$03,$00,$00,$00
	DB $FC,$FC,$FF,$FF,$FF,$FC,$FC,$30
	DB $00,$00,$00,$FC,$00,$00,$00,$00
	DB $30,$30,$30,$30,$30,$30,$00,$00

	DB $30,$30,$30,$30,$30,$30,$30,$30
	DB $00,$00,$03,$FF,$03,$00,$00,$00
	DB $FC,$FC,$FF,$FF,$FF,$FC,$FC,$30
	DB $00,$00,$00,$FC,$00,$00,$00,$00
	DB $30,$30,$30,$30,$30,$30,$30,$00
	
anim_ptrs
	DW star_anim+00*$28
	DW star_anim+01*$28
	DW star_anim+02*$28
	DW star_anim+03*$28
	DW star_anim+04*$28
	DW star_anim+05*$28
	DW star_anim+06*$28
	DW star_anim+07*$28
	DW star_anim+08*$28
	DW star_anim+09*$28
	DW star_anim+10*$28
	DW star_anim+11*$28
	DW star_anim+10*$28
	DW star_anim+09*$28
	DW star_anim+08*$28
	DW star_anim+07*$28
	DW star_anim+06*$28
	DW star_anim+05*$28
	DW star_anim+04*$28
	DW star_anim+03*$28
	DW star_anim+02*$28
	DW star_anim+01*$28
	DW star_anim+00*$28
	
mul14_lo
	DB (00*14) & 255
	DB (01*14) & 255
	DB (02*14) & 255
	DB (03*14) & 255
	DB (04*14) & 255
	DB (05*14) & 255
	DB (06*14) & 255
	DB (07*14) & 255
	DB (08*14) & 255
	DB (09*14) & 255
	DB (10*14) & 255
	DB (11*14) & 255
	DB (12*14) & 255
	DB (13*14) & 255
	DB (14*14) & 255
	DB (15*14) & 255
	DB (16*14) & 255
	DB (17*14) & 255
	DB (18*14) & 255
	DB (19*14) & 255
	DB (20*14) & 255
	DB (21*14) & 255
	DB (22*14) & 255
	DB (23*14) & 255
	DB (24*14) & 255
	DB (25*14) & 255
	DB (26*14) & 255
	DB (27*14) & 255
	DB (28*14) & 255
	DB (29*14) & 255
	DB (30*14) & 255
	DB (31*14) & 255
	DB (32*14) & 255
	DB (33*14) & 255
	DB (34*14) & 255
	DB (35*14) & 255
	DB (36*14) & 255
	DB (37*14) & 255
	DB (38*14) & 255
	DB (39*14) & 255
	
mul14_hi
	DB (00*14) >> 8
	DB (01*14) >> 8
	DB (02*14) >> 8
	DB (03*14) >> 8
	DB (04*14) >> 8
	DB (05*14) >> 8
	DB (06*14) >> 8
	DB (07*14) >> 8
	DB (08*14) >> 8
	DB (09*14) >> 8
	DB (10*14) >> 8
	DB (11*14) >> 8
	DB (12*14) >> 8
	DB (13*14) >> 8
	DB (14*14) >> 8
	DB (15*14) >> 8
	DB (16*14) >> 8
	DB (17*14) >> 8
	DB (18*14) >> 8
	DB (19*14) >> 8
	DB (20*14) >> 8
	DB (21*14) >> 8
	DB (22*14) >> 8
	DB (23*14) >> 8
	DB (24*14) >> 8
	DB (25*14) >> 8
	DB (26*14) >> 8
	DB (27*14) >> 8
	DB (28*14) >> 8
	DB (29*14) >> 8
	DB (30*14) >> 8
	DB (31*14) >> 8
	DB (32*14) >> 8
	DB (33*14) >> 8
	DB (34*14) >> 8
	DB (35*14) >> 8
	DB (36*14) >> 8
	DB (37*14) >> 8
	DB (38*14) >> 8
	DB (39*14) >> 8
	
	; ---
	
voldown_table
	include "voldown_hex.asm"
voldown_table_end

	; ---
	
size0	DB 0,0,0,0,0,0,0,0,0,0,0,0,0,0	
size1	DB 0,0,0,0,0,1,11,1,0,0,0,0,0,0
size2	DB 0,0,0,0,1,1,9,1,1,0,0,0,0,0
size3	DB 0,0,0,1,1,2,5,2,1,1,0,0,0,0
size4	DB 0,0,1,1,2,2,2,2,1,1,1,0,0,0
size5	DB 0,1,1,1,1,2,2,1,1,1,1,1,0,0
size6	DB 1,1,1,1,1,1,1,1,1,1,1,1,1,0
size7	DB 1,1,1,0,0,1,1,1,1,1,1,1,1,1
	
	ORG $1800
charset
	include "logo_charset.asm"
	
	ALIGN 256
	include "numbers_charset.asm"
	
	ALIGN 256
numbers
	include "numbers_charmap.asm"
charmap
	include "logo_charmap.asm"   

colormap
	; F yell, A red, C pur, E blue, B cyan, D green,
	DB $6f,$6f,$6f,$6f,$6f,$3a,$3a,$3a,$3a,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6f,$6f,$6f,$6f,$6f,$3a,$3a,$3a,$3a,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6f,$6f,$6f,$6f,$6f,$3a,$3a,$3a,$3a,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6f,$6f,$6f,$6f,$6f,$3a,$3a,$3a,$29,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6f,$6f,$6f,$6f,$6f,$3a,$29,$29,$29,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6f,$6f,$6f,$6f,$6f,$3a,$29,$29,$29,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	
	DB $6a,$6a,$6a,$6a,$6a,$3c,$3c,$3c,$3c,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6a,$6a,$6a,$6a,$6a,$3c,$3c,$3c,$3c,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6a,$6a,$6a,$6a,$6a,$3c,$3c,$3c,$29,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6a,$6a,$6a,$6a,$6a,$3c,$29,$29,$29,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6a,$6a,$6a,$6a,$6a,$3c,$29,$29,$29,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	
	DB $6c,$6c,$6c,$6c,$6c,$3e,$3e,$3e,$3e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6c,$6c,$6c,$6c,$6c,$3e,$3e,$3e,$3e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6c,$6c,$6c,$6c,$6c,$3e,$3e,$3e,$29,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6c,$6c,$6c,$6c,$6c,$3e,$3e,$3e,$3e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6c,$6c,$6c,$6c,$6c,$3e,$3e,$3e,$3e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	
	DB $6e,$6e,$6e,$6e,$6e,$3b,$3b,$3b,$3b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6e,$6e,$6e,$6e,$6e,$3b,$3b,$3b,$3b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6e,$6e,$6e,$6e,$6e,$3b,$3b,$3b,$29,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6e,$6e,$6e,$6e,$6e,$3b,$3b,$3b,$3b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $6e,$6e,$6e,$6e,$6e,$3b,$3b,$3b,$3b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	
	DB $5d,$5d,$5d,$5d,$5d,$2f,$2f,$2f,$2f,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5d,$5d,$5d,$5d,$5d,$2f,$2f,$2f,$2f,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5d,$5d,$5d,$5d,$5d,$2f,$2f,$2f,$2f,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	
	DB $5b,$5b,$5b,$5b,$5b,$2d,$2d,$2d,$2d,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5b,$5b,$5b,$5b,$5b,$2d,$2d,$2d,$2d,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5b,$5b,$5b,$5b,$5b,$2d,$2d,$2d,$2d,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5b,$5b,$5b,$5b,$5b,$2d,$2d,$2d,$2d,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5b,$5b,$5b,$5b,$5b,$2d,$2d,$2d,$2d,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	
	DB $5e,$5e,$5e,$5e,$5e,$2b,$2b,$2b,$2b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5e,$5e,$5e,$5e,$5e,$2b,$2b,$2b,$2b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5e,$5e,$5e,$5e,$5e,$2b,$2b,$2b,$2b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5e,$5e,$5e,$5e,$5e,$2b,$2b,$2b,$2b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5e,$5e,$5e,$5e,$5e,$2b,$2b,$2b,$2b,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	
	DB $5c,$5c,$5c,$5c,$5c,$2e,$2e,$2e,$2e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5c,$5c,$5c,$5c,$5c,$2e,$2e,$2e,$2e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5c,$5c,$5c,$5c,$5c,$2e,$2e,$2e,$2e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5c,$5c,$5c,$5c,$5c,$2e,$2e,$2e,$2e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5c,$5c,$5c,$5c,$5c,$2e,$2e,$2e,$2e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0
	DB $5c,$5c,$5c,$5c,$5c,$2e,$2e,$2e,$2e,$29,$29,$29,$29,$3F
	;DB 0,0,0,0,0,0,0,0,0,0,0,0

logo_appear
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	;
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	;
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	;
	DB size0 & 255
	;
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	;
	DB size1 & 255
	DB size2 & 255
	DB 0
	DB size3 & 255
	DB 0
	DB 0
	DB size4 & 255
	DB 0
	DB 0
	DB 0
	DB size5 & 255
	DB 0
	DB 0
	DB 0
	DB 0
	DB size6 & 255
	DB 0
	DB 0
	DB 0
	DB 0
	DB 0
	DB size7 & 255
	DB 0,0,0,0,0,0
	DB size6 & 255
	;
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	;
	DB size5 & 255
	DB 0,0,0,0
	DB size4 & 255
	DB 0,0,0,0
	DB size3 & 255
	DB 0,0,0,0
	DB size2 & 255
	DB 0,0,0,0
	DB size1 & 255
	DB 0,0,0,0
	DB size0 & 255
	;
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	DB 0,0,0,0,0, 0,0,0,0,0
	;
num0	= (numbers & 255)+00*5
num1	= (numbers & 255)+01*5
num2	= (numbers & 255)+02*5
num3	= (numbers & 255)+03*5
num4	= (numbers & 255)+04*5
num5	= (numbers & 255)+05*5
num6	= (numbers & 255)+06*5
num7	= (numbers & 255)+07*5
num8	= (numbers & 255)+08*5
num9	= (numbers & 255)+09*5

	ALIGN 256
num_data
	DB $FF,24
	DB pos1,num1,0
	DB $FF,20
	DB pos1,num2,0
	DB $FF,16
	DB pos1,num3,0
	DB $FF,13
	DB pos1,num4,0
	DB $FF,10
	DB pos1,num5,0
	DB $FF,8 
	DB pos1,num6,0
	DB $FF,6 
	DB pos1,num7,0
	DB $FF,5
	DB pos1,num8,0
	DB $FF,4
	DB pos1,num9,0
	
	DB pos2,num1,pos3,num0,0
	DB pos3,num1,0
	DB pos3,num2,0
	DB pos3,num3,0
	DB pos3,num4,0
	DB pos3,num5,0
	DB pos3,num6,0
	DB pos3,num7,0
	DB pos3,num8,0
	DB pos3,num9,0
	
	DB pos2,num2,pos3,num0,0
	DB pos3,num1,0
	DB pos3,num2,0
	DB pos3,num3,0
	DB pos3,num4,0
	DB pos3,num5,0
	DB pos3,num6,0
	DB pos3,num7,0
	DB pos3,num8,0
	DB pos3,num9,0
	
	DB pos2,num3,pos3,num0,0
	DB pos3,num1,0
	DB pos3,num2,0
	DB pos3,num3,0
	DB pos3,num4,0
	DB pos3,num5,0
	DB pos3,num6,0
	DB pos3,num7,0
	DB pos3,num8,0
	DB pos3,num9,0
	
	DB pos2,num4,pos3,num0,0
	DB pos3,num1,0
	DB pos3,num2,0
	DB pos3,num3,0
	DB pos3,num4,0
	DB pos3,num5,0
	DB pos3,num6,0
	DB pos3,num7,0
	DB pos3,num8,0
	DB pos3,num9,0
	
	DB $FF,5
	
	DB pos2,num5,pos3,num0,0
	DB pos3,num1,0
	DB pos3,num2,0
	DB pos3,num3,0
	DB pos3,num4,0
	DB pos3,num5,0
	DB pos3,num6,0
	DB pos3,num7,0
	DB pos3,num8,0
	DB pos3,num9,0
	
	DB $FF,6
	
	DB pos2,num6,pos3,num0,0
	DB pos3,num1,0
	DB pos3,num2,0
	DB pos3,num3,0
	DB pos3,num4,0
	DB pos3,num5,0
	DB pos3,num6,0
	DB pos3,num7,0
	DB pos3,num8,0
	DB pos3,num9,0
	
	DB $FF,7
	
	DB pos2,num7,pos3,num0,0
	DB pos3,num1,0
	DB pos3,num2,0
	DB pos3,num3,0
	DB pos3,num4,0
	DB pos3,num5,0
	DB pos3,num6,0
	DB pos3,num7,0
	DB pos3,num8,0
	DB pos3,num9,0
	
	DB $FF,8
	
	DB pos2,num8,pos3,num0,0
	DB pos3,num1,0
	DB pos3,num2,0
	DB pos3,num3,0
	DB pos3,num4,0
	DB pos3,num5,0
	DB pos3,num6,0
	DB pos3,num7,0
	DB pos3,num8,0
	DB pos3,num9,0
	
	DB $FF,9
	
	DB pos2,num9,pos3,num0,0
	DB $FF,10
	DB pos3,num1,0
	DB $FF,11
	DB pos3,num2,0
	DB $FF,12
	DB pos3,num3,0
	DB $FF,14
	DB pos3,num4,0
	DB $FF,16
	DB pos3,num5,0
	DB $FF,18
	DB pos3,num6,0
	DB $FF,20
	DB pos3,num7,0
	DB $FF,25
	DB pos3,num8,0
	DB $FF,30
	DB pos3,num9,0
	DB $FF,50
	
	DB pos4,num1,pos5,num0,pos6,num0,0
	
sp_pos
	DW $0C54+6*40
	DW $0C54+1*40
	DW $0C54+5*40
	DW $0C54+3*40
	DW $0C54+8*40
	DW $0C54+4*40
	DW $0C54-1*40
	DW $0C54+2*40
	
	;
	; ---------------------------------
	;
	include "digiplay.asm"
	include "digimusic.asm"
	include "!player.asm"
	include "music.asm"
;[eof]